﻿using System;
using System.Windows;
using System.Windows.Forms;
using System.Windows.Media;

using TestLibrary;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 커스텀 컨트롤
        /// </summary>
        private CustomControl customControl;

        private System.Windows.Media.SolidColorBrush initialBackgroundBrush;

        private System.Windows.Media.SolidColorBrush initialForegroundBrush;

        private System.Windows.Media.FontFamily initialFontFamily;

        private double initialFontSize;

        private System.Windows.FontWeight initialFontWeight;

        private System.Windows.FontStyle initialFontStyle;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.customControl = new CustomControl();

            this.customControl.InitializeComponent();

            this.elementHost.Child = this.customControl;

            this.customControl.ButtonClick                   += customControl_ButtonClick;
            this.customControl.Loaded                        += customControl_Loaded;
            this.originalBackgroundColorRadioButton.Click    += originalBackgroundColorRadioButton_Click;
            this.lightGreenBackgroundColorRadioButton.Click  += lightGreenBackgroundColorRadioButton_Click;
            this.lightSalmonBackgroundColorRadioButton.Click += lightSalmonBackgroundColorRadioButton_Click;
            this.originalForegroundColorRadioButton.Click    += originalForegroundColorRadioButton_Click;
            this.redForegroundColorRadioButton.Click         += redForegroundColorRadioButton_Click;
            this.yellowForegroundColorRadioButton.Click      += yellowForegroundColorRadioButton_Click;
            this.originalFontFamilyRadioButton.Click         += originalFontFamilyRadioButton_Click;
            this.timesNewRomanFontFamilyRadioButton.Click    += timesNewRomanFontFamilyRadioButton_Click;
            this.windingsFontFamilyRadioButton.Click         += windingsFontFamilyRadioButton_Click;
            this.originalFontSizeRadioButton.Click           += originalFontSizeRadioButton_Click;
            this.twelveFontSizeRadioButton.Click           += twelveFontSizeRadioButton_Click;
            this.twentyFontSizeRadioButton.Click           += twentyFontSizeRadioButton_Click;
            this.originalFontStyleRadioButton.Click          += originalFontStyleRadioButton_Click;
            this.italicFontStyleRadioButton.Click            += italicFontStyleRadioButton_Click;
            this.originalFontWeightRadioButton.Click         += originalFontWeightRadioButton_Click;
            this.boldFontWeightRadioButton.Click             += boldFontWeightRadioButton_Click;
        }

        #endregion

        #region Original 배경색 라디오 버튼 클릭시 처리하기 - originalBackgroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// Original 배경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalBackgroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.BackgroundBrush = this.initialBackgroundBrush;
        }

        #endregion
        #region LightGreen 배경색 라디오 버튼 클릭시 처리하기 - lightGreenBackgroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// LightGreen 배경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void lightGreenBackgroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.BackgroundBrush = new SolidColorBrush(Colors.LightGreen);
        }

        #endregion
        #region LightSalmon 배경색 라디오 버튼 클릭시 처리하기 - lightSalmonBackgroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// LightSalmon 배경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void lightSalmonBackgroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.BackgroundBrush = new SolidColorBrush(Colors.LightSalmon);
        }

        #endregion
        #region Original 전경색 라디오 버튼 클릭시 처리하기 - originalForegroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// Original 전경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalForegroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.ForegroundBrush = this.initialForegroundBrush;
        }

        #endregion
        #region Red 전경색 라디오 버튼 클릭시 처리하기 - redForegroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// Red 전경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void redForegroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.ForegroundBrush = new System.Windows.Media.SolidColorBrush(Colors.Red);
        }

        #endregion
        #region Yellow 전경색 라디오 버튼 클릭시 처리하기 - yellowForegroundColorRadioButton_Click(sender, e)

        /// <summary>
        /// Yellow 전경색 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void yellowForegroundColorRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.ForegroundBrush = new System.Windows.Media.SolidColorBrush(Colors.Yellow);
        }

        #endregion
        #region Original 폰트 패밀리 라디오 버튼 클릭시 처리하기 - originalFontFamilyRadioButton_Click(sender, e)

        /// <summary>
        /// Original 폰트 패밀리 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalFontFamilyRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontFamily = this.initialFontFamily;
        }

        #endregion
        #region Times New Roman 폰트 패밀리 라디오 버튼 클릭시 처리하기 - timesNewRomanFontFamilyRadioButton_Click(sender, e)

        /// <summary>
        /// Times New Roman 폰트 패밀리 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timesNewRomanFontFamilyRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontFamily = new System.Windows.Media.FontFamily("Times New Roman");
        }

        #endregion
        #region Windings 폰트 패밀리 라디오 버튼 클릭시 처리하기 - windingsFontFamilyRadioButton_Click(sender, e)

        /// <summary>
        /// Windings 폰트 패밀리 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void windingsFontFamilyRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontFamily = new System.Windows.Media.FontFamily("WingDings");
        }

        #endregion
        #region Original 폰트 크기 라디오 버튼 클릭시 처리하기 - originalFontSizeRadioButton_Click(sender, e)

        /// <summary>
        /// Original 폰트 크기 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalFontSizeRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontSize = this.initialFontSize;
        }

        #endregion
        #region 12 폰트 크기 라디오 버튼 클릭시 처리하기 - twelveFontSizeRadioButton_Click(sender, e)

        /// <summary>
        /// 12 폰트 크기 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void twelveFontSizeRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontSize = 12;
        }

        #endregion
        #region 20 폰트 크기 라디오 버튼 클릭시 처리하기 - twentyFontSizeRadioButton_Click(sender, e)

        /// <summary>
        /// 20 폰트 크기 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void twentyFontSizeRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontSize = 20;
        }

        #endregion
        #region Original 폰트 스타일 라디오 버튼 클릭시 처리하기 - originalFontStyleRadioButton_Click(sender, e)

        /// <summary>
        /// Original 폰트 스타일 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalFontStyleRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontStyle = this.initialFontStyle;
        }

        #endregion
        #region Italic 폰트 스타일 라디오 버튼 클릭시 처리하기 - italicFontStyleRadioButton_Click(sender, e)

        /// <summary>
        /// Italic 폰트 스타일 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void italicFontStyleRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontStyle = System.Windows.FontStyles.Italic;
        }

        #endregion
        #region Original 폰트 가중치 라디오 버튼 클릭시 처리하기 - originalFontWeightRadioButton_Click(sender, e)

        /// <summary>
        /// Original 폰트 가중치 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void originalFontWeightRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontWeight = this.initialFontWeight;
        }

        #endregion
        #region Bold 폰트 가중치 라디오 버튼 클릭시 처리하기 - boldFontWeightRadioButton_Click(sender, e)

        /// <summary>
        /// Bold 폰트 가중치 라디오 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void boldFontWeightRadioButton_Click(object sender, EventArgs e)
        {
            this.customControl.FontWeight = FontWeights.Bold;
        }

        #endregion

        #region 커스텀 컨트롤 로드시 처리하기 - customControl_Loaded(sender, e)

        /// <summary>
        /// 커스텀 컨트롤 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void customControl_Loaded(object sender, RoutedEventArgs e)
        {
            this.initialBackgroundBrush  = (System.Windows.Media.SolidColorBrush)this.customControl.BackgroundBrush;
            this.initialForegroundBrush  = this.customControl.ForegroundBrush;
            this.initialFontFamily       = this.customControl.FontFamily;
            this.initialFontSize         = this.customControl.FontSize;
            this.initialFontWeight       = this.customControl.FontWeight;
            this.initialFontStyle        = this.customControl.FontStyle;
        }

        #endregion
        #region 커스텀 컨트롤 버튼 클릭시 처리하기 - customControl_ButtonClick(sender, e)

        /// <summary>
        /// 커스텀 컨트롤 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void customControl_ButtonClick(object sender, CustomControlEventArgs e)
        {
            if(e.OKButtonClicked)
            {
                this.addressLabel.Text = "Address : " + e.Address;
                this.cityLabel.Text    = "City : "    + e.City;
                this.nameLabel.Text    = "Name : "    + e.Name;
                this.stateLabel.Text   = "State : "   + e.State;
                this.zipLabel.Text     = "Zip : "     + e.Zip;
            }
            else
            {
                this.addressLabel.Text = "Address :";
                this.cityLabel.Text    = "City :";
                this.nameLabel.Text    = "Name :";
                this.stateLabel.Text   = "State :";
                this.zipLabel.Text     = "Zip :";
            }
        }

        #endregion
    }
}